
package examenjava_2013_2014.ejercicio1_examen;

public class Dispositivo {
    private Instruccion [] cola;
    private int numInstrucciones;
    
    public Dispositivo(){
        this.cola=new Instruccion[100];
        this.numInstrucciones=-1;
    }
    
    public Dispositivo(int tama_max){
        
        this.cola=new Instruccion[tama_max];
        this.numInstrucciones=-1;
    }
    
    public void putInstruccion(Instruccion i)
    {
        if(this.numInstrucciones+1<this.cola.length)
        {
            this.numInstrucciones++;
            this.cola[this.numInstrucciones]=i;
        }
    }
    
    public int count_codigo(String codigo)
    {
        int contador=0;
        for(int i=0;i<=this.numInstrucciones;i++)
        {
            if(this.cola[i].getCodigo().compareTo(codigo)==0) 
            {
                contador++;
            }
        }
        return(contador);
    }
    
    public void ejecutarInstruccion(){
        if(this.numInstrucciones<0)
        {
            System.out.println("Dispositivo vacio");
        }
        else
        {
            StringBuffer texto=new StringBuffer("\nSe ha ejecutado la instrucción ");
            texto.append(this.cola[0].getCodigo()+" con prioridad ");
            texto.append(this.cola[0].prioridad+" y tiempo ");
            texto.append(this.cola[0].tiempo+" FIN\n");
            System.out.println(texto);
            for(int i=0;i<this.numInstrucciones;i++)
            {      
                this.cola[i]=this.cola[i+1];
            }
            this.numInstrucciones--;
        }
        
    }
}
